#ifndef _BITMAP_
#define _BITMAP_

#include <stdint.h>

enum bitmap_status {
    OK,
    FILE_ERROR,
    BAD_BMP_FILE_ERROR,
    OUT_OF_MEMORY_ERROR,
    UNSUPPORTED_FILE_FORMAT_ERROR
};

typedef enum bitmap_status bitmap_status_t;

struct rgb_tag {
    uint8_t  blue;
    uint8_t  green;
    uint8_t  red;
};

typedef struct rgb_tag rgb_t;

struct bitmap_tag {
    uint32_t  size;
    uint32_t  num_pixels;
    uint32_t  width;
    uint32_t  height;
    uint8_t*  contents;
    rgb_t*    pixels;
};

typedef struct bitmap_tag bitmap_t;

#define GET_PIXEL(obj, x, y) ((obj).pixels + ((x) + (obj).width * (y)))

extern bitmap_status_t bitmap_create(const char* name, bitmap_t* obj);
extern bitmap_status_t bitmap_dispose(bitmap_t* obj);
extern bitmap_status_t bitmap_store(const char* name, bitmap_t* obj);

#endif
