#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <bitmap.h>

int main(void) {
    bitmap_t bm;
    bitmap_status_t status;
    
    status = bitmap_create("flor.bmp", &bm);
    printf("Status = %d\n", status);
    if (status == OK) {
        printf("Ancho  = %d\n", bm.width);
        printf("Alto   = %d\n", bm.height);
        printf("Tamaño = %d\n", bm.size);
        // Este ciclo permite procesar todos los píxeles a partir de sus
        // coordenadas x, y.
        for (int y = 0; y < bm.height; y++) {
            for (int x = 0; x < bm.width; x++) {
                rgb_t* pixel = GET_PIXEL(bm, x, y);            
                pixel->red = 0;
                pixel->blue = 0;                
            }
        }
        /*
        // Este ciclo permite procesar todos los píxeles de forma secencial.
        for (int i = 0; i < bm.num_pixels; i++) {
            bm.pixels[i].red = 0;
            bm.pixels[i].blue = 0;
        }
        */
        bitmap_store("otra.bmp", &bm);
        bitmap_dispose(&bm);
        printf("La imagen ha sido convertida a verde.\n");
    }
    
    return 0;
}
